<?php
require_once 'config.php';
require_once 'functions.php';

session_start();
if (!isset($_SESSION['admin']) && $_SERVER['REQUEST_METHOD'] === 'POST') {
    if ($_POST['password'] === 'Gemini12!') {
        $_SESSION['admin'] = true;
    }
}

if (!isset($_SESSION['admin'])) {
    echo '<form method="post"><input type="password" name="password"><input type="submit" value="Belépés"></form>';
    exit;
}

$osztaly_lista = ['9/Ny.N', '9.A', '9.B', '9.G', '9.N', '10.A', '10.B', '10.C', '10.G', '10.N', '11.A', '11.B', '11.C', '11.G', '11.N', '12.A', '12.B', '12.G', '12.N', '12.P', '13.A', '13.B', '13.C', '13.P'];

// Top 3 diák lekérdezése
$top_3_diakok = $db->query("SELECT d.id, d.om_azonosito, d.nev, d.osztaly, COUNT(i.id) as kartya_szam
                            FROM diakok d
                            LEFT JOIN igenyles i ON d.id = i.diak_id
                            GROUP BY d.id
                            ORDER BY kartya_szam DESC
                            LIMIT 3");

// Összes diák lekérdezése
$szuro_osztaly = isset($_GET['szuro_osztaly']) ? $_GET['szuro_osztaly'] : '';
$osszes_diak_query = "SELECT d.id, d.om_azonosito, d.nev, d.osztaly, COUNT(i.id) as kartya_szam
                      FROM diakok d
                      LEFT JOIN igenyles i ON d.id = i.diak_id";
if ($szuro_osztaly) {
    $osszes_diak_query .= " WHERE d.osztaly = '$szuro_osztaly'";
}
$osszes_diak_query .= " GROUP BY d.id ORDER BY d.nev";
$osszes_diak = $db->query($osszes_diak_query);

// Folyamatban lévő és elkészült kártya igénylések listája
$igenyles_lista = $db->query("SELECT i.id, d.nev, d.osztaly, i.igenyles_datum, i.statusz, i.tipus 
                              FROM igenyles i 
                              JOIN diakok d ON i.diak_id = d.id 
                              WHERE i.statusz IN ('Folyamatban', 'Elkészült')
                              ORDER BY i.igenyles_datum DESC");

$statusz_opciok = ['Folyamatban', 'Elkészült', 'Átvéve', 'Megtalálta', 'Nem kell'];

// Státusz frissítése
if (isset($_POST['update_status'])) {
    $igenyles_id = $_POST['igenyles_id'];
    $new_status = $_POST['new_status'];
    $stmt = $db->prepare("UPDATE igenyles SET statusz = ? WHERE id = ?");
    $stmt->bind_param("si", $new_status, $igenyles_id);
    $stmt->execute();
    header("Location: ".$_SERVER['PHP_SELF']);
    exit();
}

// Osztály tömeges módosítása
if (isset($_POST['update_osztaly'])) {
    $diak_ids = $_POST['diak_ids'] ?? [];
    $new_osztaly = $_POST['new_osztaly'];
    if (!empty($diak_ids) && $new_osztaly) {
        $placeholders = implode(',', array_fill(0, count($diak_ids), '?'));
        $types = str_repeat('i', count($diak_ids));
        $stmt = $db->prepare("UPDATE diakok SET osztaly = ? WHERE id IN ($placeholders)");
        $stmt->bind_param("s" . $types, $new_osztaly, ...$diak_ids);
        $stmt->execute();
        header("Location: ".$_SERVER['PHP_SELF']);
        exit();
    }
}

// Üzenet kezelése
if (isset($_POST['set_message'])) {
    $message = $_POST['message'];
    $is_blinking = isset($_POST['is_blinking']) ? 1 : 0;
    $stmt = $db->prepare("INSERT INTO messages (message, is_blinking, sorrend) VALUES (?, ?, (SELECT COALESCE(MAX(sorrend), 0) + 1 FROM messages m))");
    $stmt->bind_param("si", $message, $is_blinking);
    $stmt->execute();
}

if (isset($_POST['delete_message'])) {
    $message_id = $_POST['message_id'];
    $stmt = $db->prepare("DELETE FROM messages WHERE id = ?");
    $stmt->bind_param("i", $message_id);
    $stmt->execute();
}

if (isset($_POST['move_message'])) {
    $message_id = $_POST['message_id'];
    $direction = $_POST['direction'];
    
    $stmt = $db->prepare("SELECT sorrend FROM messages WHERE id = ?");
    $stmt->bind_param("i", $message_id);
    $stmt->execute();
    $result = $stmt->get_result();
    $current_order = $result->fetch_assoc()['sorrend'];
    
    if ($direction === 'up' && $current_order > 1) {
        $db->query("UPDATE messages SET sorrend = sorrend + 1 WHERE sorrend = " . ($current_order - 1));
        $db->query("UPDATE messages SET sorrend = sorrend - 1 WHERE id = " . $message_id);
    } elseif ($direction === 'down') {
        $db->query("UPDATE messages SET sorrend = sorrend - 1 WHERE sorrend = " . ($current_order + 1));
        $db->query("UPDATE messages SET sorrend = sorrend + 1 WHERE id = " . $message_id);
    }
}

// Üzenetek lekérdezése
$messages = $db->query("SELECT * FROM messages ORDER BY sorrend ASC");

// Rendszerfigyelő funkciók
function getCpuUsage() {
    $load = sys_getloadavg();
    return $load[0];
}

function getMemoryUsage() {
    $free = shell_exec('free');
    $free = (string)trim($free);
    $free_arr = explode("\n", $free);
    $mem = explode(" ", $free_arr[1]);
    $mem = array_filter($mem);
    $mem = array_merge($mem);
    $memory_usage = $mem[2]/$mem[1]*100;
    return round($memory_usage, 2);
}

function getDiskUsage() {
    $disktotal = disk_total_space('/');
    $diskfree = disk_free_space('/');
    $diskuse = round(($disktotal - $diskfree) / $disktotal * 100, 2);
    return $diskuse;
}

$cpu_usage = getCpuUsage();
$memory_usage = getMemoryUsage();
$disk_usage = getDiskUsage();

?>

<!DOCTYPE html>
<html lang="hu">
<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Admin Felület</title>
    <link href="https://fonts.googleapis.com/css2?family=Roboto:wght@300;400;700&display=swap" rel="stylesheet">
    <style>
        body {
            font-family: 'Roboto', sans-serif;
            line-height: 1.6;
            color: #333;
            max-width: 1200px;
            margin: 0 auto;
            padding: 20px;
            background-color: #f0f4f8;
        }
        .logo {
            text-align: center;
            margin-bottom: 30px;
        }
        .logo img {
            max-width: 150px;
            height: auto;
        }
        h1, h2, h3 {
            color: #2c3e50;
            text-align: center;
        }
        .section {
            background-color: #fff;
            padding: 25px;
            border-radius: 8px;
            margin-bottom: 30px;
            box-shadow: 0 4px 6px rgba(0,0,0,0.1);
        }
        table {
            width: 100%;
            border-collapse: collapse;
            margin-bottom: 20px;
        }
        th, td {
            border: 1px solid #ddd;
            padding: 12px;
            text-align: left;
        }
        th {
            background-color: #3498db;
            color: white;
        }
        tr:nth-child(even) {
            background-color: #f8f9fa;
        }
        select, input[type="submit"], textarea {
            padding: 8px;
            border-radius: 4px;
            margin-bottom: 10px;
        }
        input[type="submit"] {
            background-color: #3498db;
            color: white;
            border: none;
            cursor: pointer;
            transition: background-color 0.3s ease;
        }
        input[type="submit"]:hover {
            background-color: #2980b9;
        }
        .links {
            text-align: center;
            margin-top: 30px;
        }
        .links a {
            display: inline-block;
            margin: 0 10px;
            padding: 10px 20px;
            background-color: #3498db;
            color: white;
            text-decoration: none;
            border-radius: 5px;
            transition: background-color 0.3s ease;
        }
        .links a:hover {
            background-color: #2980b9;
        }
        .toggle-btn {
            background-color: #3498db;
            color: white;
            border: none;
            padding: 10px 20px;
            cursor: pointer;
            border-radius: 5px;
            margin-bottom: 10px;
        }
        .toggle-btn:hover {
            background-color: #2980b9;
        }
        #osszes-diak, #system-monitor-section, #message-section {
            display: none;
        }
        .filter-form {
            margin-bottom: 20px;
        }
        .osztaly-update {
            margin-top: 20px;
            padding-top: 20px;
            border-top: 1px solid #ddd;
        }
        .message-controls {
            display: flex;
            justify-content: space-between;
            align-items: center;
        }
        .message-controls form {
            display: inline;
        }
        .system-monitor {
            display: flex;
            justify-content: space-around;
            margin-bottom: 20px;
        }
        .monitor-item {
            text-align: center;
            width: 30%;
        }
        .monitor-label {
            margin-bottom: 10px;
            font-weight: bold;
        }
        .progress-bar {
            background-color: #e0e0e0;
            height: 20px;
            border-radius: 10px;
            overflow: hidden;
        }
        .progress {
            height: 100%;
            transition: width 0.5s ease-in-out;
        }
        .monitor-value {
            margin-top: 5px;
        }
    </style>
</head>
<body>
    <div class="logo">
        <img src="image/kanizsay.png" alt="Kanizsay logo">
    </div>

    <h1>Admin Felület</h1>

    <button id="toggleSystemMonitor" class="toggle-btn">Rendszerfigyelő mutatása</button>

    <div id="system-monitor-section" class="section">
        <h2>Rendszerfigyelő</h2>
        <div class="system-monitor">
            <div class="monitor-item">
                <div class="monitor-label">CPU Használat</div>
                <div class="progress-bar">
                    <div id="cpu-progress" class="progress" style="width: <?php echo $cpu_usage; ?>%;"></div>
                </div>
                <div id="cpu-value" class="monitor-value"><?php echo $cpu_usage; ?>%</div>
            </div>
            <div class="monitor-item">
                <div class="monitor-label">Memória Használat</div>
                <div class="progress-bar">
                    <div id="memory-progress" class="progress" style="width: <?php echo $memory_usage; ?>%;"></div>
                </div>
                <div id="memory-value" class="monitor-value"><?php echo $memory_usage; ?>%</div>
            </div>
            <div class="monitor-item">
                <div class="monitor-label">Tárhely Használat</div>
                <div class="progress-bar">
                    <div id="disk-progress" class="progress" style="width: <?php echo $disk_usage; ?>%;"></div>
                </div>
                <div id="disk-value" class="monitor-value"><?php echo $disk_usage; ?>%</div>
            </div>
        </div>
    </div>

    <button id="toggleMessageSection" class="toggle-btn">Üzenet beállítása szekció mutatása</button>

    <div id="message-section" class="section">
        <h2>Üzenetek beállítása a tabletre</h2>
        <form method="post">
            <textarea name="message" rows="4" cols="50" placeholder="Írd be az új üzenetet"></textarea><br>
            <label>
                <input type="checkbox" name="is_blinking"> Villogó üzenet
            </label><br>
            <input type="submit" name="set_message" value="Üzenet hozzáadása">
        </form>

        <h3>Jelenlegi üzenetek:</h3>
        <?php while ($message = $messages->fetch_assoc()): ?>
            <div class="message-controls">
                <p><?= htmlspecialchars($message['message']) ?> 
                   <?= $message['is_blinking'] ? '(Villogó)' : '' ?>
                </p>
                <div>
                    <form method="post" style="display: inline;">
                        <input type="hidden" name="message_id" value="<?= $message['id'] ?>">
                        <input type="hidden" name="direction" value="up">
                        <input type="submit" name="move_message" value="&#9650;">
                    </form>
                    <form method="post" style="display: inline;">
                        <input type="hidden" name="message_id" value="<?= $message['id'] ?>">
                        <input type="hidden" name="direction" value="down">
                        <input type="submit" name="move_message" value="&#9660;">
                    </form>
                    <form method="post" style="display: inline;">
                        <input type="hidden" name="message_id" value="<?= $message['id'] ?>">
                        <input type="submit" name="delete_message" value="Törlés">
                    </form>
                </div>
            </div>
        <?php endwhile; ?>
    </div>

    <div class="section">
        <h2>Folyamatban lévő és elkészült kártya/matrica igénylések</h2>
        <table>
            <tr>
                <th>Név</th>
                <th>Osztály</th>
                <th>Igénylés Dátuma</th>
                <th>Típus</th>
                <th>Státusz</th>
                <th>Művelet</th>
            </tr>
            <?php while ($row = $igenyles_lista->fetch_assoc()): ?>
            <tr>
                <td><?= htmlspecialchars($row['nev']) ?></td>
                <td><?= htmlspecialchars($row['osztaly']) ?></td>
                <td><?= htmlspecialchars($row['igenyles_datum']) ?></td>
                <td><?= htmlspecialchars($row['tipus']) ?></td>
                <td><?= htmlspecialchars($row['statusz']) ?></td>
                <td>
                    <form method="post">
                        <input type="hidden" name="igenyles_id" value="<?= $row['id'] ?>">
                        <select name="new_status">
                            <?php foreach ($statusz_opciok as $statusz): ?>
                                <option value="<?= $statusz ?>" <?= $row['statusz'] == $statusz ? 'selected' : '' ?>>
                                    <?= $statusz ?>
                                </option>
                            <?php endforeach; ?>
                        </select>
                        <input type="submit" name="update_status" value="Frissít">
                    </form>
                </td>
            </tr>
            <?php endwhile; ?>
        </table>
    </div>

    <div class="section">
        <h2>Diákok listája és kártya statisztika</h2>
        <div id="top-3-diakok">
            <h3>Top 3 legtöbb kártyát igénylő diák</h3>
            <table>
                <tr>
                    <th>OM azonosító</th>
                    <th>Név</th>
                    <th>Osztály</th>
                    <th>Igényelt kártyák száma</th>
                </tr>
                <?php while ($row = $top_3_diakok->fetch_assoc()): ?>
                <tr>
                    <td><?= htmlspecialchars($row['om_azonosito']) ?></td>
                    <td><?= htmlspecialchars($row['nev']) ?></td>
                    <td><?= htmlspecialchars($row['osztaly']) ?></td>
                    <td><?= $row['kartya_szam'] ?></td>
                </tr>
                <?php endwhile; ?>
            </table>
        </div>
        
        <button id="toggleBtn" class="toggle-btn" onclick="toggleDiakok()">Összes diák mutatása</button>

        <div id="osszes-diak">
            <h3>Összes diák</h3>
            <form method="get" class="filter-form">
                <select name="szuro_osztaly">
                    <option value="">Minden osztály</option>
                    <?php foreach ($osztaly_lista as $osztaly): ?>
                        <option value="<?= $osztaly ?>" <?= $szuro_osztaly === $osztaly ? 'selected' : '' ?>>
                            <?= $osztaly ?>
                        </option>
                    <?php endforeach; ?>
                </select>
                <input type="submit" value="Szűrés">
            </form>
            <form method="post">
                <table>
                    <tr>
                        <th>Kijelölés</th>
                        <th>OM azonosító</th>
                        <th>Név</th>
                        <th>Osztály</th>
                        <th>Igényelt kártyák száma</th>
                    </tr>
                    <?php while ($row = $osszes_diak->fetch_assoc()): ?>
                    <tr>
                        <td><input type="checkbox" name="diak_ids[]" value="<?= $row['id'] ?>"></td>
                        <td><?= htmlspecialchars($row['om_azonosito']) ?></td>
                        <td><?= htmlspecialchars($row['nev']) ?></td>
                        <td><?= htmlspecialchars($row['osztaly']) ?></td>
                        <td><?= $row['kartya_szam'] ?></td>
                    </tr>
                    <?php endwhile; ?>
                </table>
                <div class="osztaly-update">
                    <h4>Kijelölt diákok osztályának módosítása</h4>
                    <select name="new_osztaly">
                        <?php foreach ($osztaly_lista as $osztaly): ?>
                            <option value="<?= $osztaly ?>"><?= $osztaly ?></option>
                        <?php endforeach; ?>
                    </select>
                    <input type="submit" name="update_osztaly" value="Osztály módosítása">
                </div>
            </form>
        </div>
    </div>

    <div class="links">
        <a href="diak_felvetel.php">Új diák felvétele</a>
        <a href="tomeg_felvetel.php">Diákok tömeges felvétele</a>
        <a href="kartyi.php">Összes kártya igénylés megtekintése</a>
        <a href="diaktorles.php">Diákok törlése</a>
        <a href="igenytorles.php">Igénylések törlése</a>
    </div>

    <script>
        function toggleDiakok() {
            var osszesDiak = document.getElementById('osszes-diak');
            var toggleBtn = document.getElementById('toggleBtn');
            if (osszesDiak.style.display === 'none' || osszesDiak.style.display === '') {
                osszesDiak.style.display = 'block';
                toggleBtn.textContent = 'Összes diák elrejtése';
            } else {
                osszesDiak.style.display = 'none';
                toggleBtn.textContent = 'Összes diák mutatása';
            }
        }

        function toggleSystemMonitor() {
            var section = document.getElementById('system-monitor-section');
            var btn = document.getElementById('toggleSystemMonitor');
            if (section.style.display === 'none' || section.style.display === '') {
                section.style.display = 'block';
                btn.textContent = 'Rendszerfigyelő elrejtése';
                updateSystemMonitor();
            } else {
                section.style.display = 'none';
                btn.textContent = 'Rendszerfigyelő mutatása';
            }
        }

        function toggleMessageSection() {
            var section = document.getElementById('message-section');
            var btn = document.getElementById('toggleMessageSection');
            if (section.style.display === 'none' || section.style.display === '') {
                section.style.display = 'block';
                btn.textContent = 'Üzenet beállítása szekció elrejtése';
            } else {
                section.style.display = 'none';
                btn.textContent = 'Üzenet beállítása szekció mutatása';
            }
        }

        function updateSystemMonitor() {
    fetch('get_system_info.php')
        .then(response => response.json())
        .then(data => {
            updateProgressBar('cpu', data.cpu.percentage);
            updateProgressBar('memory', data.memory.percentage);
            updateProgressBar('disk', data.disk.percentage);
            
            // Opcionális: részletesebb információk megjelenítése
            document.getElementById('cpu-value').textContent = `${data.cpu.percentage}% (${data.cpu.load} / ${data.cpu.cores} mag)`;
            document.getElementById('memory-value').textContent = `${data.memory.percentage}% (${data.memory.used}GB / ${data.memory.total}GB)`;
            document.getElementById('disk-value').textContent = `${data.disk.percentage}% (${data.disk.used}GB / ${data.disk.total}GB)`;
        });
}

function updateProgressBar(type, value) {
    const progressBar = document.getElementById(`${type}-progress`);
    const valueDisplay = document.getElementById(`${type}-value`);
    progressBar.style.width = `${value}%`;

    if (value < 60) {
        progressBar.style.backgroundColor = '#2ecc71';  // Zöld
    } else if (value < 80) {
        progressBar.style.backgroundColor = '#f39c12';  // Narancs
    } else {
        progressBar.style.backgroundColor = '#e74c3c';  // Piros
    }
}

        document.getElementById('toggleSystemMonitor').addEventListener('click', toggleSystemMonitor);
        document.getElementById('toggleMessageSection').addEventListener('click', toggleMessageSection);

        // Frissítés 5 másodpercenként, ha a rendszerfigyelő látható
        setInterval(() => {
            if (document.getElementById('system-monitor-section').style.display !== 'none') {
                updateSystemMonitor();
            }
        }, 5000);
    </script>
</body>
</html>