<?php
header('Content-Type: application/json');

function getCpuUsage() {
    $load = sys_getloadavg();
    $cores = 2; // A virtuális gép 2 maggal rendelkezik
    $usage = min(100, round($load[0] * 100 / $cores, 2)); // Limitáljuk 100%-ra
    return [
        'percentage' => $usage,
        'load' => $load[0],
        'cores' => $cores
    ];
}

function getMemoryUsage() {
    $meminfo = file_get_contents('/proc/meminfo');
    preg_match_all('/(\w+):\s+(\d+)\s/', $meminfo, $matches);
    $meminfo = array_combine($matches[1], $matches[2]);
    $total = $meminfo['MemTotal'];
    $free = $meminfo['MemFree'];
    $buffers = $meminfo['Buffers'];
    $cached = $meminfo['Cached'];
    $used = $total - $free - $buffers - $cached;
    $usedGB = round($used / 1024 / 1024, 2);
    $totalGB = round($total / 1024 / 1024, 2);
    $percentage = round($used / $total * 100, 2);
    return [
        'percentage' => $percentage,
        'used' => $usedGB,
        'total' => $totalGB
    ];
}

function getDiskUsage() {
    $disktotal = disk_total_space('/');
    $diskfree = disk_free_space('/');
    $diskused = $disktotal - $diskfree;
    $percentage = round($diskused / $disktotal * 100, 2);
    $usedGB = round($diskused / 1024 / 1024 / 1024, 2);
    $totalGB = round($disktotal / 1024 / 1024 / 1024, 2);
    return [
        'percentage' => $percentage,
        'used' => $usedGB,
        'total' => $totalGB
    ];
}

$data = [
    'cpu' => getCpuUsage(),
    'memory' => getMemoryUsage(),
    'disk' => getDiskUsage()
];

echo json_encode($data);