<?php
require_once 'config.php';
require_once 'functions.php';

header('Content-Type: application/json');

$input = json_decode(file_get_contents('php://input'), true);

if (isset($input['action'])) {
    switch ($input['action']) {
        case 'lekerdezes':
            $om_azonosito = $input['om_azonosito'];
            $stmt = $db->prepare("SELECT d.id, d.nev, d.osztaly, COUNT(i.id) as kartya_szam 
                                  FROM diakok d 
                                  LEFT JOIN igenyles i ON d.id = i.diak_id AND i.tipus = 'kartya'
                                  WHERE d.om_azonosito = ?
                                  GROUP BY d.id");
            $stmt->bind_param("s", $om_azonosito);
            $stmt->execute();
            $result = $stmt->get_result();
            echo json_encode($result->fetch_assoc());
            break;

        case 'igenyles':
            $diak_id = $input['diak_id'];
            $tipus = $input['tipus'];
            $stmt = $db->prepare("INSERT INTO igenyles (diak_id, tipus, statusz) VALUES (?, ?, 'Folyamatban')");
            $stmt->bind_param("is", $diak_id, $tipus);
            $success = $stmt->execute();
            echo json_encode(['success' => $success]);
            break;

        default:
            echo json_encode(['error' => 'Ismeretlen művelet']);
    }
} else {
    echo json_encode(['error' => 'Hiányzó művelet']);
}