<?php
require_once 'config.php';
require_once 'functions.php';

session_start();
if (!isset($_SESSION['admin'])) {
    header('Location: admin.php');
    exit;
}

function getElkeszultKartyak() {
    global $db;
    $elkeszult_kartyak = $db->query("SELECT d.nev, d.osztaly
                                     FROM igenyles i 
                                     JOIN diakok d ON i.diak_id = d.id 
                                     WHERE i.statusz = 'Elkészült'
                                     ORDER BY d.nev");
    return $elkeszult_kartyak;
}

if (isset($_GET['ajax'])) {
    $elkeszult_kartyak = getElkeszultKartyak();
    $response = '';
    if ($elkeszult_kartyak->num_rows > 0) {
        while ($row = $elkeszult_kartyak->fetch_assoc()) {
            $response .= '<div class="message">';
            $response .= '<p>Kedves ' . htmlspecialchars($row['nev']) . '!</p>';
            $response .= '<p>Kártyád elkészült és átvehető a NAGY szünetek valamelyikében.</p>';
            $response .= '</div>';
        }
    } else {
        $response = '<p>Jelenleg nincs átvehető kártya.</p>';
    }
    echo $response;
    exit;
}

$elkeszult_kartyak = getElkeszultKartyak();
?>

<!DOCTYPE html>
<html lang="hu">
<head>
    <meta charset="UTF-8">
    <title>Elkészült Kártyák</title>
    <style>
        body { font-family: Arial, sans-serif; max-width: 800px; margin: 0 auto; padding: 20px; }
        .message { background-color: #f0f0f0; padding: 10px; border-radius: 5px; margin-bottom: 20px; }
    </style>
    <script src="https://code.jquery.com/jquery-3.6.0.min.js"></script>
</head>
<body>
    <h1>Elkészült Kártyák</h1>

    <div id="kartyak-container">
        <?php if ($elkeszult_kartyak->num_rows > 0): ?>
            <?php while ($row = $elkeszult_kartyak->fetch_assoc()): ?>
                <div class="message">
                    <p>Kedves <?= htmlspecialchars($row['nev']) ?>!</p>
                    <p>Kártyád elkészült és átvehető a NAGY szünetek valamelyikében.</p>
                </div>
            <?php endwhile; ?>
        <?php else: ?>
            <p>Jelenleg nincs átvehető kártya.</p>
        <?php endif; ?>
    </div>

    <a href="admin.php">Vissza az admin felületre</a>

    <script>
        function frissitKartyak() {
            $.get('elkeszult_kartyak.php?ajax=1', function(data) {
                $('#kartyak-container').html(data);
            });
        }

        // 10 másodpercenként frissítjük az adatokat
        setInterval(frissitKartyak, 10000);
    </script>
</body>
</html>